/**
* Create a new user.
* UsernameAvailable: if user name is available or not
*/
controller.createNewUser = function (usernameAvailable) {
	var username = document.getElementById("desUsername").value.toLowerCase();
	var password = document.getElementById("passwordField").value;
	var firstName = document.getElementById("firstName").value;
	var lastName = document.getElementById("lastName").value;
	var email = document.getElementById("email").value;
	var country = document.getElementById("country").value;

	function usernameIsAvailable() {
		alert("usernameAvailable " + usernameAvailable);
		if (usernameAvailable != "illegal" && usernameAvailable != "occupied") {
			return true;
		} else {
			return false;
		}
	}

	function emailIsCorrect() {
		alert("check email: " + email);
		var str = email;
		var lastAtPos = str.lastIndexOf('@');
		var lastDotPos = str.lastIndexOf('.');
		return (lastAtPos < lastDotPos && lastAtPos > 0 && str.indexOf('@@') ==  -
			1 && lastDotPos > 2 && (str.length - lastDotPos) > 2);

	}

	function passwordLengthIsOk() {
		alert("check password: " + password);
		if (password.length >= 5) {
			return true;
		} else {
			return false;
		}
	}

	function success(msg) {
		//Log in!
		alert("Done: " + msg);
        $('#loadingSign').sfLoading('hide');
		controller.handleLogin(username, password, false);
	//sf.scene.hide('SignUpScene');

	}

	function failure(res) {
		$('#loadingSign').sfLoading('hide');
		alert("Failed to create account: " + res['httpErrorCode']);
		if (res['httpErrorCode'] == 500) {
			msg = STR_USERNAME_NOT_AVAILABLE;
		} else {
			if (msg == "")
				msg =
					"We are experiencing problems with the server. Please try again later";
		}
		$('#validation_popup').sfPopup({
			text : STR_SIGN_POPUP + " " + msg,
			buttons : ["Ok"],
			defaultFocus : 0,
			callback : function logoutCallback(selectedIndex) {}
		});
		$('#validation_popup').sfPopup('show');
	}

	var msg = "";
	//Validations:
	if (!($('##SceneSignUpScene #agreement_checkbox').sfCheckBox('getChecked'))) {
		msg = msg + STR_UA_VALIDATOR + " </br>";
		$jq("#agreement_checkbox").css('border', '2px solid red');
	} else {
		$jq("#agreement_checkbox").css('border', '0px solid grey');
	}
	if (!usernameIsAvailable()) {
		//username not available
		msg = msg + STR_USERNAME_NOT_AVAILABLE + " </br>";
		$jq("#desUsername").css('border', '2px solid red');
	} else {
		$jq("#desUsername").css('border', '1px solid grey');
	}
	if (firstName == "") {
		//first name can't be blank
		msg = msg + STR_FIRST_NAME_VALIDATOR + " </br>";
		$jq("#firstName").css('border', '2px solid red');
	} else {
		$jq("#firstName").css('border', '1px solid grey');
	}
	if (lastName == "") {
		//Last name can't be blank.
		msg = msg + STR_LAST_NAME_VALIDATOR + " </br>";
		$jq("#lastName").css('border', '2px solid red');
	} else {
		$jq("#lastName").css('border', '1px solid grey');
	}
	if (!emailIsCorrect()) {
		//email incorrect
		msg = msg + STR_EMAIL_INCORRECT + " </br>";
		$jq("#email").css('border', '2px solid red');
	} else {
		$jq("#email").css('border', '1px solid grey');
	}
	if (!passwordLengthIsOk()) {
		//password too short
		msg = msg + STR_PASSWORD_VALIDATOR + "</br>";
		$jq("#passwordField").css('border', '2px solid red');
	} else {
		$jq("#passwordField").css('border', '1px solid grey');
	}

	if (msg != "") {
		alert("Validation failed due to:" +msg);
		$('#validation_popup').sfPopup({
			text : STR_SIGN_POPUP + " " + msg,
			buttons : ["Ok"],
			defaultFocus : 0,
			callback : function logoutCallback(selectedIndex) {}
		});
		$('#validation_popup').sfPopup('show');
	} else {
		alert("Create Account and log in");
        $('#loadingSign').sfLoading('show');
        model.createAccount(firstName, lastName, username, password, email, country).done(success).fail(failure);
		//success();
	}
}

// sends request to server to check the desired username
controller.checkUsername = function (str) {
	function success(msg) {
		alert("Check username done: " + msg);
		var result = msg;
		$jq("#username_validator").empty();
		$jq("#username_validator").append("Username " + document.getElementById(
				"desUsername").value.toLowerCase() + " is " + result);
	}

	function failure(msg) {
		alert("Failed to check username");
	}

	url = "/ajax/username_check.php?username=" + str;
	payload = "";
	type = "GET";
	contentType = "text/html";
	//model.checkName(url, payload, type, contentType).done(success).fail(failure);
	baxide.restInvoke(url, payload, type, contentType).done(success).fail(failure);
}
