function SceneDriveScene(options) {
	this.options = options;
	this.scroll = null;
	this.scrollSize = 133;

}

var currentTab = "clouddrive";
var folderListIndex;
var favoritesListIndex;
var backward; // If going to parent folder
var currentFocused; // current item focused
var currentRow; // current row
var numberElements; // number of elements in grid
var gridId;
var multipleSelect; // multiple select option true/false
var selectedItems; // selected items
var selectedItemsId; // selected items
var copy;
var move;
var PlayerPlugin;
var currentAudio;
var playingAudio;
var favoriteId;
var loading;

SceneDriveScene.prototype.initialize = function () {
	alert("SceneDriveScene.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here
	// scene HTML and CSS will be loaded before this function is called
	PlayerPlugin = sf.core.plugin('PLAYER');
	$("#newFolder").prepend(STR_NEW_FOLDER);
	$("#rename").prepend(STR_RENAME);
	$(".delete").prepend(STR_DELETE);
	$("#copy").prepend(STR_COPY);
	$("#move").prepend(STR_MOVE);
	$("#multipleSelect").prepend(STR_MULTIPLE_SELECT);
	$("#addFavorite").prepend(STR_ADD_FAVORITE);
	$("#share").prepend(STR_SHARE);
	$("#movePl").prepend(STR_MOVE);
	$("#remove").prepend(STR_REMOVE);
	$("#load").prepend(STR_LOAD);
	$("#clear").prepend(STR_CLEAR);
	$("#save").prepend(STR_SAVE);

	alert("tvYear " + tvYear);
	if (tvYear == "2011") {
		gridId = "#folderGrid_Maple";
		$('#folderGrid').remove();
	} else {
		gridId = "#folderGrid";
		$('#folderGrid_Maple').remove();
	}
	playingAudio = false;
	currentTab = "clouddrive";
	favoriteId = null;
	currentFocused = null;
	currentRow = 0;
	$('#fav_description').prepend(STR_DESCRIPTION);
	$('#fav_shared').prepend(STR_SHARED_BY);
}

SceneDriveScene.prototype.handleShow = function () {
	alert("SceneDriveScene.handleShow()");
	// this function will be called when the scene manager show this scene
	loginTimeEnd = new Date().getTime();
	try {
		alert("Login time: " + (loginTimeEnd - loginTimeInitial) + " milliseconds");
	} catch (err) {
		alert("Calculating login time error: " + err);
	}

	$('#svecKeyHelp_IIZH').sfKeyHelp({
		'user' : states.username,
		'red' : STR_LOGOUT,
		'green' : STR_SORT,
		'yellow' : STR_PLAYQUEUE,
		'blue' : STR_SEARCH,
		'enter' : STR_ENTER,
		'updown' : STR_UP_DOWN,
		'info' : STR_FILE_INFO,
		'return' : STR_BACK
	});

	controller.diskUsage();
	backward = false;
	multipleSelect = false;
	if ($(".avatar").length > 0)
		$(".avatar").remove();

  //Display user avatar
	if (states.avatar != undefined) {
		var link = baxide.generateUrl(states.avatar);
		var img = null;
		img = new Image();
		img.src = "";
		img.onload = function () {
			alert("avatar loaded");
			$('#cloudme').prepend("<img class='avatar' src='" + link + "' width='60' height='60'/>");
			img = null;
			delete(img);
		}
		img.onerror = function () {
			$('#cloudme').prepend("<img class='avatar' src='images/avatar.png' width='60' height='60'/>");
			img = null;
			delete(img);
		}
		img.src = link;
	} else {
		$('#cloudme').prepend("<img class='avatar' src='images/avatar.png' width='60' height='60'/>");
	}
	if (currentTab == "clouddrive") {
		this.setCloudDrive();
	}
	if (currentTab == "favorites") {
		this.setFavorites();
	}
	loading = false;
}

SceneDriveScene.prototype.handleHide = function () {
	alert("SceneDriveScene.handleHide()");
	numberElements = null;
	favoritesListIndex = null;
	folderListIndex = null;
}


SceneDriveScene.prototype.handleFocus = function (reload) { //If reload is true, do nothing
	// this function will be called when the scene manager focus this scene
	//NAvigation help:
	$("#SceneDriveScene").css('visibility', 'visible');
	if (reload == null || !reload) {
		controller.drawRoute(currentTab);
		currentFocused = 0;
		currentRow = 0;
		move = false;
		copy = false;

		$(gridId).empty();
		$('#loadingDrive').sfLoading('hide');
		if (folderListIndex == null) {
			folderListIndex = new Array();
		}
		if (favoritesListIndex == null) {
			favoritesListIndex = new Array();
		}
		alert("SceneDriveScene.handleFocus()");

		$(gridId).css("top", 35);
		this.drawItems(currentTab);
		multipleSelect = false;
		$("#multipleSelect").css('background', 'white');
		selectedItems = new Array();
		selectedItemsId = new Array();
		this.showVolume();
		if (currentTab == "favorites" && favoritesRoute.length == 1) {
			controller.openFavorite(fold[currentFocused].id, false);

		}
		//	currentRow =Math.min(Math.floor(currentFocused/filesPerRow),3); // set focused row
		if (currentTab == "clouddrive" && folderIdTree[folderIdTree.length - 1] == 0) { //hide msearch menu
			this.setSearch();
		} else {
			this.unsetSearch();
		}
		alert("currentRow " + currentRow);
		controller.registerArrowKeys();
	}
}

SceneDriveScene.prototype.handleBlur = function () {
	alert("SceneDriveScene.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

SceneDriveScene.prototype.handleKeyDown = function (keyCode) {
	alert("SceneDriveScene.handleKeyDown(" + keyCode + ")");

	var index = 0;
	switch (keyCode) {
	case sf.key.LEFT: // Move focus to the left in the grid
		index = -1;
		
		if (currentFocused > 0) {
			this.unFocusCell();
			if ((currentFocused) % filesPerRow == 0) {
				this.moveGridUp();
				if (currentRow > 0)
					currentRow--;
			}
			this.focusCell(index);
		} /*else {
			currentFocused = numberElements - 1;
			this.focusCell(0);
			currentRow = 3;

		}*/
		if (currentTab == "favorites" && favoritesRoute.length == 1) {
			controller.openFavorite(fold[currentFocused].id, false);

		}
		this.loadMore();
		break;
	case sf.key.RIGHT: // Move focus to the right in the grid
		index = +1;
		if (currentFocused < (numberElements - 1)) {
			this.unFocusCell();
			if ((currentFocused + 1) % filesPerRow == 0) {
				this.moveGridDown();
				if (currentRow < 3)
					currentRow++;
			}
			this.focusCell(index);
		} /*else {
			currentFocused = 0;
			this.focusCell(0);
			currentRow = 0;

		}*/
		if (currentTab == "favorites" && favoritesRoute.length == 1) {
			controller.openFavorite(fold[currentFocused].id, false);

		}
		this.loadMore();
		break;
	case sf.key.UP: // Move focus up in the grid
		index = -filesPerRow;
		if (currentFocused >= filesPerRow) {
			this.unFocusCell();

			this.moveGridUp();
			if (currentRow > 0)
				currentRow--;
			this.focusCell(index);
		}
		if (currentTab == "favorites" && favoritesRoute.length == 1) {
			controller.openFavorite(fold[currentFocused].id, false);

		}
		break;
	case sf.key.DOWN: // Move focus down in the grid
		index = +filesPerRow;
		alert("currentFocused  " + currentFocused);
		alert("numberElements " + numberElements);
		if (currentFocused < (numberElements - filesPerRow)) {
			this.unFocusCell();

			//Move the scroll
			this.moveGridDown();
			if (currentRow < 3)
				currentRow++;
			this.focusCell(index);
		}
		if (currentTab == "favorites" && favoritesRoute.length == 1) {
			controller.openFavorite(fold[currentFocused].id, false);

		}
		this.loadMore();
		break;

	case sf.key.ENTER:
		alert("active cell: " + $(".cell.focus").attr("class"));
		//FAVORITES TAB
		if (currentTab == "favorites") {
			if (currentFocused < fold.length) { //If is a folder, open it
				controller.unregisterArrowKeys();
				$('#loadingDrive').sfLoading('show');
				if (fold[currentFocused]) {
					controller.setRoute(true, currentTab);
					$("." + currentFocused + ".cell").removeClass("focus");
					//states.currentFolderId = null;
					var id = fold[currentFocused].id;
					if (favoriteId == null || favoritesListIndex.length == 0) {
						favoriteId = fold[currentFocused].id;
					}
					controller.openFavorite(favoriteId, true, favoritesRoute);
					favoritesListIndex.push(currentFocused); // add to a list the current focused so we know where we were when going backwards
					currentFocused = null;
				}
			} else { //Else, check the file type and open it if possible
				controller.handleFile();
			}
		}
		//CLOUD DRIVE TAB
		else {
			if (multipleSelect) // If multiple select option is pressed select/unselect the item
			{
				controller.selectItem();
			} else { // else, open the folder or file
				alert("currentFocused " + currentFocused);
				if (currentFocused < fold.length) { //If is a folder, open it
					alert("Is a Folder");
					controller.unregisterArrowKeys();
					$('#loadingDrive').sfLoading('show');
					if (fold[currentFocused]) {
						controller.setRoute(true, currentTab);
						$("." + currentFocused + ".cell").removeClass("focus");
						states.currentFolderId = null;
						if (folderIdTree[(folderIdTree.length - 1)] == 0) { //if we are in a search result, calculate the route
							controller.findRoute(fold[currentFocused].id, fold[currentFocused].name);
						}
						controller.handleFolder(fold[currentFocused].id);
						folderListIndex.push(currentFocused); // add to a list the current focused so we know where we were when going backwards
						currentFocused = null;
					}
				} else { //Else, check the file type and open it if possible
					controller.handleFile();
				}
			}
		}
		break;

	case sf.key.RETURN:
		alert("return");
		//FAVORITES TAB
		if (currentTab == "favorites" && favoritesRoute.length > 1) {
			$('#loadingDrive').sfLoading('show');
			controller.setRoute(false, currentTab);
			backward = true;
			//					$('#foldersList').sfList('blur');
			$("." + currentFocused + ".cell").removeClass("focus");
			favoritesRoute.pop();
			if (favoritesRoute.length == 1) {
				favoriteId = null;
				controller.loadFavorites();
			} else {
				controller.openFavorite(favoriteId, true, favoritesRoute);
			}
		} else {
			//CLOUD DRIVE TAB
			if (folderIdTree.length > 1 && currentTab == "clouddrive") {
				states.currentFolderId = null;
				$('#loadingDrive').sfLoading('show');
				folderIdTree.pop();
				controller.setRoute(false, currentTab);
				backward = true;
				//					$('#foldersList').sfList('blur');
				$("." + currentFocused + ".cell").removeClass("focus");
				$('#iframe').remove();
				var fId = folderIdTree.pop();
				if (fId == 0) { // if there is a search result, open it
					fold = search.searchResultFolders;
					folderFiles = search.searchResultFiles;
					while (folderRoute.length > (folderIdTree.length + 1))
						folderRoute.pop();
					//check images and audio files
					var i;
					audioFiles = new Array();
					imageFiles = new Array();
					for (i = 0; i < folderFiles.length; i++) {
						if (folderFiles[i].mime == "audio/mp3" || folderFiles[i].mime == "audio/mpeg") {
							audioFiles.push(folderFiles[i]);
						}
						if (folderFiles[i].mime == "image/jpeg" || folderFiles[i].mime == "image/jpg" || folderFiles[i].mime == "image/png" || folderFiles[i].mime == "image/gif") {
							imageFiles.push(folderFiles[i]);
						}
					}
					folderIdTree.push(0);
					sf.scene.focus('DriveScene');
				} else {
					controller.handleFolder(fId); //get the last folder we where in
				}
			} else {
				controller.exit();
			}
		}
		sf.key.preventDefault();
		break;

	case sf.key.RED: //DIsplay log out pop up
		if (playingAudio) {
			$("#musicPlay").attr("src", "images/control/media_play.png");
			$("#musicPause").attr("src", "images/control/media_pause_red.png");
			PlayerPlugin.Pause();
		}
		//Show logout popup
		$('#logout_popup').sfPopup({
			text : STR_LOGOUT_POPUP,
			buttons : [STR_YES, STR_NO],
			defaultFocus : 1,
			callback : function logoutCallback(selectedIndex) {
				if (selectedIndex == 0) {
					alert("Loging out");
					sf.scene.hide("DriveScene");
					controller.logout();
				}
			}
		});
		$('#logout_popup').sfPopup('show');
		break;

	case sf.key.GREEN: //sort items
		//Sort
		//TUrn around the array and draw items
		if (currentTab == "clouddrive") {
			$('#logout_popup').sfPopup({
				text : STR_SORT_POPUP,
				buttons : ["Title Asc", "Title Desc"],
				defaultFocus : 0,
				callback : function logoutCallback(selectedIndex) {
					switch (selectedIndex) {
					case 0:
						$('#loadingDrive').sfLoading('show');
						$("." + currentFocused + ".cell").removeClass("focus");
						controller.handleFolder(states.currentFolderId, true, "title");
						break;
					case 1:
						$('#loadingDrive').sfLoading('show');
						$("." + currentFocused + ".cell").removeClass("focus");
						controller.handleFolder(states.currentFolderId, false, "title");
						break;

					}
				}
			});
			$('#logout_popup').sfPopup('show');
		}
		break;
    
	case sf.key.YELLOW: // open playqueue
		//			this.drawPlayQueueMenu();
		sf.scene.show("PlayQueueScene");
		sf.scene.focus("PlayQueueScene");
		break;

	case sf.key.BLUE: //SEARCH popup
		if (currentTab == "clouddrive") {
			controller.getFolderId();
			//Show newFolder popup
			$('#newFolder_popup').sfPopup({
				text : STR_SEARCH,
				buttons : [STR_OK, STR_CANCEL],
				timeout : 0,
				defaultFocus : -1,
				callback : function newFolderCallback(selectedIndex) {
					if (selectedIndex == 0) {
						controller.search($('#newFolderInput').val());
						$('#loadingDrive').sfLoading('show');
					}
				},
				onkeydown : function (keyCode) {
					alert("KEYDOWN : " + keyCode);
					switch (keyCode) {
					case sf.key.UP:
						document.getElementById("newFolderInput").focus();						
						//$('#newFolder_popup').sfPopup("option", "focus", "0");
						break;

					case sf.key.LEFT:
						$('#newFolder_popup').sfPopup("option", "focus", "0");
						break;

					case sf.key.RIGHT:
						$('#newFolder_popup').sfPopup("option", "focus", "1");
						break;
					case sf.key.ENTER:
						$('#newFolder_popup').sfPopup('hide');
						break;
					}
				}
			});
			$('#newFolder_popup').sfPopup('show');

			$('#newFolder_popup').append('<input id="newFolderInput" type="text" size="20" />');
			var ime_newFolder = new IMEShell("newFolderInput", callback_newFolder, "en");
			var xPosition;
			switch (sf.env.getResolution()) {
			case '540p':
				xPosition = 680;
				break;
			case '720p':
				xPosition = 880;
				break;
			case '1080p':
				xPosition = 1080;
				break;
			}

			ime_newFolder.setKeypadPos(xPosition, 70, 9);

			ime_newFolder.setString("");
			document.getElementById("newFolderInput").focus(); //focus the input title
			$("#ime_keypad").css('opacity', '1');
			$("#ime_keypad").css('z-index', '50');
		}
		break;

	case sf.key.INFO: // display the info of a file
		this.showInfo();
		break;

	case sf.key.N1: //cloud drive tab
		// clear grid
		// draw grid
		// register n4-n9
		if (currentTab != "clouddrive") {
			currentFocused = null;
			this.setCloudDrive();

		}

		break;

	case sf.key.N2: //Webshares tab
		if (currentTab != "webshares") {
			$("#fav_description").css("visibility", "hidden");
			//			$('#loadingDrive').sfLoading('show');
			currentTab = "webshares";
			this.drawMenu(currentTab); //change menu
			this.selectTab(currentTab);
			//favoriteId = null;
			controller.getWebShares();
			currentFocused = null;

		}
		break;

	case sf.key.N3: //Favorites tab
		if (currentTab != "favorites") {
			this.setFavorites();
			currentFocused = null;
		}

		break;

	case sf.key.N4: //Create New Folder popup
		//Show newFolder popup
		if (folderIdTree[folderIdTree.length - 1] != 0) { //FORBID create new folder in search result
			if (currentTab == "clouddrive") {

				$('#newFolder_popup').sfPopup({
					text : STR_NEW_FOLDER_POPUP,
					buttons : [STR_OK, STR_CANCEL],
					timeout : 0,
					defaultFocus : -1,
					callback : function newFolderCallback(selectedIndex) {
						if (selectedIndex == 0) {
							alert("current folder id: " + states.currentFolderId);
							alert("Callback called, file name: " + $('#newFolderInput').val());
							controller.addNewFolder($('#newFolderInput').val());
						}
					},
					onkeydown : function (keyCode) {
						alert("KEYDOWN : " + keyCode);
						switch (keyCode) {
						case sf.key.UP:
							document.getElementById("newFolderInput").focus();
							$('#newFolder_popup').sfPopup("option", "focus", "-1");
							break;

						case sf.key.LEFT:
							$('#newFolder_popup').sfPopup("option", "focus", "0");
							break;

						case sf.key.RIGHT:
							$('#newFolder_popup').sfPopup("option", "focus", "1");
							break;
						case sf.key.ENTER:
							$('#newFolder_popup').sfPopup('hide');
							break;
						}
					}
				});
				$('#newFolder_popup').sfPopup('show');

				$('#newFolder_popup').append('<input id="newFolderInput" type="text" size="20" />');
				var ime_newFolder = new IMEShell("newFolderInput", callback_newFolder, "en");
				var xPosition;
				switch (sf.env.getResolution()) {
				case '540p':
					xPosition = 680;
					break;
				case '720p':
					xPosition = 880;
					break;
				case '1080p':
					xPosition = 1080;
					break;
				}

				ime_newFolder.setKeypadPos(xPosition, 70, 9);

				ime_newFolder.setString("New Folder");
				document.getElementById("newFolderInput").focus(); //focus the input title
				$("#ime_keypad").css('opacity', '1');
				$("#ime_keypad").css('z-index', '50');
			}
		}
		break;

	case sf.key.N5://RENAME popup
		if (currentTab == "clouddrive") { 
			alert("Rename");
			//Show newFolder popup
			$('#newFolder_popup').sfPopup({
				text : STR_RENAME_POPUP,
				buttons : [STR_OK, STR_CANCEL],
				timeout : 0,
				defaultFocus : -1,
				callback : function newFolderCallback(selectedIndex) {
					alert("popup_callback");
					if (selectedIndex == 0) {
						alert("current folder id: " + states.currentFolderId);
						alert("Callback called, file name: " + $('#newFolderInput').val());
						if (currentFocused < fold.length) {
							item = fold[currentFocused];
						} else {
							item = folderFiles[(currentFocused - fold.length)];
						}
						alert("item: " + item);
						controller.rename($('#newFolderInput').val(), item);
					}
				},
				onkeydown : function (keyCode) {
					alert("KEYDOWN : " + keyCode);
					switch (keyCode) {
					case sf.key.UP:
						document.getElementById("newFolderInput").focus();
						$('#newFolder_popup').sfPopup("option", "focus", "-1");
						break;

					case sf.key.LEFT:
						$('#newFolder_popup').sfPopup("option", "focus", "0");
						break;

					case sf.key.RIGHT:
						$('#newFolder_popup').sfPopup("option", "focus", "1");
						break;
					case sf.key.ENTER:
						$('#newFolder_popup').sfPopup('hide');
						break;
					}
				}
			});
			$('#newFolder_popup').sfPopup('show');
			$('#newFolder_popup').append('<input id="newFolderInput" type="text" size="20" />');
			ime_newFolder = new IMEShell("newFolderInput", callback_newFolder, "en");
			ime_newFolder.setString("");
			var xPosition;
			switch (sf.env.getResolution()) {
			case '540p':
				xPosition = 680;
				break;
			case '720p':
				xPosition = 880;
				break;
			case '1080p':
				xPosition = 1080;
				break;
			}
			ime_newFolder.setKeypadPos(xPosition, 70, 9);
			document.getElementById("newFolderInput").focus(); //focus the input title
			$("#ime_keypad").css('opacity', '1');
			$("#ime_keypad").css('z-index', '50');
		} else { //FAVORITES --> ADD FAVORITE
			this.showAddFavoritePopup();
		}

		break;

	case sf.key.N6: //DELETE popup
		if (currentTab == "clouddrive" || (currentTab == "favorites" && favoritesRoute.length == 1)) {
			alert("Delete");
			$('#newFolder_popup').sfPopup({
				text : STR_DELETE_POPUP,
				buttons : [STR_YES, STR_NO],
				timeout : 0,
				defaultFocus : 1,
				callback : function newFolderCallback(selectedIndex) {
					if (selectedIndex == 0) {
						if (currentTab == "clouddrive") {
							if (selectedItems.length == 0) {
								controller.selectItem();
							}
							if (folderIdTree[(folderIdTree.length - 1)] != 0) {
								controller.deleteItem(selectedItems, true);
							} else {
								controller.deleteItem(selectedItems, false);
							}
							controller.diskUsage();
						} else {

							controller.deleteFavorite(fold[currentFocused]);
						}
					}
				}
			});
			$('#newFolder_popup').sfPopup('show');
		}
		break;

	case sf.key.N7: //COPY TO popup
		if (folderIdTree[folderIdTree.length - 1] != 0) { //FORBID create new folder in search result
			if (currentTab == "clouddrive") {

				copy = true;
				alert("Copy " + selectedItems.length);
				if (selectedItems.length == 0) {
					controller.selectItem();
				}
				$('#newFolder_popup').sfPopup({
					text : STR_COPY_POPUP,
					buttons : [STR_YES, STR_NO],
					timeout : 0,
					defaultFocus : 0,
					callback : function newFolderCallback(selectedIndex) {

						if (selectedIndex == 0) {
							$("#helper").remove();
							//controller.createFolderTree(0);
							controller.showFolderTree();

						}
						if ((selectedIndex == 1 || selectedIndex == -1) && selectedItems.length == 1) {
							controller.selectItem();
						}

					}
				});
				$('#newFolder_popup').sfPopup('show');
			}
		}
		break;

	case sf.key.N8: //MOVE TO popup
		if (folderIdTree[folderIdTree.length - 1] != 0) { //FORBID create new folder in search result
			if (currentTab == "clouddrive") {

				alert("Move to");
				move = true;
				if (selectedItems.length == 0) {
					controller.selectItem();
				}
				$('#newFolder_popup').sfPopup({
					text : STR_MOVE_POPUP,
					buttons : [STR_YES, STR_NO],
					timeout : 0,
					defaultFocus : 0,
					callback : function newFolderCallback(selectedIndex) {
						alert("selectedIndex " + selectedIndex);
						if (selectedIndex == 0) {
							$("#helper").remove();
							//controller.createFolderTree(0);
							controller.showFolderTree();

						}
						if ((selectedIndex == 1 || selectedIndex == -1) && selectedItems.length == 1) {
							controller.selectItem();
						}
					}
				});
				$('#newFolder_popup').sfPopup('show');
			}
		}
		break;

	case sf.key.N9: //MULTIPLE SELECT selected
		if (folderIdTree[folderIdTree.length - 1] != 0) { //FORBID create new folder in search result
			if (currentTab == "clouddrive") {

				alert("Multiple select");

				if (multipleSelect) {
					multipleSelect = false;
					$("#multipleSelect").css('background', 'white');
				} else {
					multipleSelect = true;
					//				$("#frame").append('<div id="helper">Multiple Select</div>');
					$("#multipleSelect").css('background', '#FAFF75');
				}
				controller.unSelectAll();
				selectedItems = new Array();
				selectedItemsId = new Array();
			}
		}
		break;

	case sf.key.N0: //Share popup
		alert("Share");
		if (currentTab == "clouddrive") {
			$('#info_popup').sfPopup({
				title : STR_COPYRIGHT_POPUP,
				text : STR_SHARE_POPUP,
				buttons : [STR_OK, STR_CANCEL],
				timeout : 0,
				defaultFocus : 0,
				callback : function newFolderCallback(selectedIndex) {
					alert("selectedIndex " + selectedIndex);
					if (selectedIndex == 0) {
						if (currentFocused >= fold.length) {
							controller.createWebShare(folderFiles[currentFocused - fold.length]);
						} else {
							controller.createWebShare(fold[currentFocused]);
						}
					}
				}
			});
			$('#info_popup').sfPopup('show');
		}
		break;

		// Music button handler:
	case sf.key.PLAY:
		alert("PLAY");
		if (playingAudio) {
			$("#musicPlay").attr("src", "images/control/media_play_green.png");
			$("#musicPause").attr("src", "images/control/media_pause.png");
			PlayerPlugin.Resume();
		} else {
			controller.playMusic();
		}

		break;

	case sf.key.STOP:
		alert("STOP");
		controller.stopAudio();

		break;

	case sf.key.PAUSE:
		alert("PAUSE");
		$("#musicPlay").attr("src", "images/control/media_play.png");
		$("#musicPause").attr("src", "images/control/media_pause_red.png");
		PlayerPlugin.Pause();
		break;

	case sf.key.FF:
		alert("FF: " + currentAudio + "  length: " + playQueue.length);
		$("#musicFF").attr("src", "images/control/media_step_forward_green.png");
		setTimeout('$("#musicFF").attr("src", "images/control/media_step_forward.png");', 1000);
		controller.playNextSong(1);
		break;

	case sf.key.REW:
		alert("RW");
		$("#musicRW").attr("src", "images/control/media_step_back_green.png");
		setTimeout('$("#musicRW").attr("src", "images/control/media_step_back.png");', 1000);
		controller.playNextSong(-1);
		break;

    case sf.key.VOL_UP:
		alert("Vol up");
		
		window.deviceapis.audiocontrol.setVolumeUp();
		//window.deviceapis.audiocontrol.setVolume(window.deviceapis.audiocontrol.getVolume + 1);
		this.showVolume();
		break;

    case sf.key.VOL_DOWN:
		alert("Vol down");
		deviceapis.audiocontrol.setVolumeDown();
		this.showVolume();
		break;

    case sf.key.MUTE:
		alert("MUTE");
		if (deviceapis.audiocontrol.getMute() == true) {
			deviceapis.audiocontrol.setMute(false);
		} else {
			deviceapis.audiocontrol.setMute(true);
		}
		this.showVolume();
		break;
	}

}
// actual function
function fnDnStatus(msg) {
	alert('fnCallback' + msg);

	var tArrResult = msg.split("?");

	for (var i = 0; i < tArrResult.length; i++) {
		alert("tArrResult[" + i + "] = " + tArrResult[i]);
	}

	// DownResult : If res=1 success, otherwise ERROR (see end of this file)
	if (tArrResult[0] == 1000) {
		//document.getElementById('DownResult').value = tArrResult[1];
	}
	// DownRatio : 0~100
	else if (tArrResult[0] == 1001) {
		// document.getElementById('DownloadedRatio').value = tArrResult[1];
	}
	// Down Speed : Bytes/Sec : It will be reach after Ratio
	else if (tArrResult[0] == 1002) {
		//document.getElementById('DownSpeed').value = tArrResult[1];
	}
}

function callback_newFolder(cb) { //popup callback function
	alert("callback called");
	cb.setKeyFunc(sf.key.DOWN, function (keyCode) {
	document.getElementById("newFolder").blur();
		sf.scene.returnFocus();
		$('#newFolder_popup').sfPopup('show');
		$('#newFolder_popup').sfPopup("option", "focus", "1");
		return false;
	});
	cb.setKeyFunc(sf.key.ENTER, function (keyCode) {
		document.getElementById("newFolder").blur();
		sf.scene.returnFocus();
		$('#newFolder_popup').sfPopup('show');
		return false;
	});
	cb.setKeyFunc(sf.key.RETURN, function (keyCode) {
		document.getElementById("newFolder").blur();
		sf.scene.returnFocus();
		$('#newFolder_popup').sfPopup('hide');
		sf.key.preventDefault();
		return false;
	});
	cb.setKeyFunc(sf.key.RIGHT, function (keyCode) {
		alert("right");
		return false;
	});
	cb.setKeyFunc(sf.key.LEFT, function (keyCode) {
		alert("left");
		return false;
	});
	cb.setKeyFunc(sf.key.UP, function (keyCode) {
		document.getElementById("newFolder").focus();
		return false;
	});
	cb.setKeyFunc(sf.key.EXIT, function (keyCode) {
		alert("exit");
		sf.core.exit(true);
	});
}

SceneDriveScene.prototype.drawItems = function (tab) { //draw items in the grid
	numberElements = fold.length + folderFiles.length;
	alert("number of elements in grid: " + numberElements);
	alert("NUmber of rows: " + Math.ceil(numberElements / filesPerRow));

	var row = new Array(Math.ceil(numberElements / filesPerRow));
	for (i = 0; i < row.length; i++) {
		row[i] = new Array(filesPerRow);
		$(gridId).append("<div class='row" + i + "' style='clear: both;'></div>");
	}

	for (i = 0; i < numberElements; i++) {
		SceneDriveScene.prototype.selectIcon(i, row, tab);
	}
	this.setFocus(tab);
	this.adjustScrollBar(rownumber, Math.floor(currentFocused / filesPerRow));
}

//add items to already drawn grid
SceneDriveScene.prototype.addItems = function (folderId) {
	alert("numberElements " + numberElements);
	alert("fold.le  " + fold.length + "   folderFiles.length " + folderFiles.length + "   totalFiles " + totalFiles);

	var alreadydrawn = numberElements;
	numberElements = fold.length + folderFiles.length
		alert("number of elements in grid: " + numberElements);
	alert("NUmber of rows: " + Math.ceil(numberElements / filesPerRow));

	alert("alreadydrawn  " + alreadydrawn);

	var currentRows = Math.ceil(alreadydrawn / filesPerRow);

	alert("currentRows " + currentRows);
	var row = new Array(Math.ceil(numberElements / filesPerRow));
	alert("row.length " + row.length);
	for (i = 0; i < row.length; i++) {
		row[i] = new Array(filesPerRow);
		if (i >= currentRows)
			$(gridId).append("<div class='row" + i + "' style='clear: both;'></div>");
	}

	for (i = alreadydrawn; i < numberElements; i++) { //from the last item to the end
		alert("i  " + i);
		SceneDriveScene.prototype.selectIcon(i, row);
	}
	this.adjustScrollBar(rownumber, Math.floor(currentFocused / filesPerRow));

}

SceneDriveScene.prototype.selectIcon = function (i, row, tab) { // select the icon image according to the file type
	if (i < fold.length) { //if its a folder
		alert("Folder type: " + fold[i].type);
		rownumber = Math.floor(i / filesPerRow);
		alert("Rownumber: " + rownumber + " i: " + i);
		if (rownumber <= Math.floor(numberElements / filesPerRow)) {
			row[rownumber][i] = fold[i].title;
			alert("fold[i].title " + fold[i].title + "currentTab " + currentTab);
			if (tab == "favorites" && favoritesRoute.length == 1) {
				if (fold[i].pwd != "") {
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/folder_fav_lock128.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
				} else {
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/folder_fav128.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
				}
			} else {
				switch (fold[i].title) {
				case "Documents":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/folder_document.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				case "CloudMe":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/folder_cloudme.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				case "Pictures":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/folder_photos.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				case "Trashcan":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/garbage.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				case "Appointments":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/calendar.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				case "Bookmarks":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/folder_bookmarks.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				case "Contacts":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/address_book.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				case "Feeds":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/folder_rss.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				case "Mail":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/mailbox_empty.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				case "Notes":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/folder_note.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				case "Public":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/folder_webshare.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				case "Brevo":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/brevo128.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				case "Movies":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/folder_movie.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				case "Music":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/folder_music.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				default:
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/folder.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + fold[i].title + "</span></div></div>");
					break;
				}
			}
		}

	} else { // if its a file
		pos = i - fold.length;
		//	aux[i]=folderFiles[pos].title;
		rownumber = Math.floor(i / filesPerRow);
		//		alert("Rownumber: "+rownumber+" i: "+i);
		if (rownumber <= Math.floor(numberElements / filesPerRow)) {
			row[rownumber][i] = folderFiles[pos].title;

			// 		$(gridId+" .row"+rownumber).append("<div class='"+i+" cell'><div class='image'><img src='images/...' width='100' height='100'/></div><div class='title'>"+folderFiles[pos].title+"</div></div>");
			switch (folderFiles[pos].type) {
			case "image":
				var l = folderFiles[pos].url || folderFiles[pos].href;
				alert("l " + l);

				if (l.charAt(l.length - 1) == "1") {
					l = l.substring(0, l.lastIndexOf("1"));
					var link = l + "32769/" + folderFiles[pos].title;
				} else {
					var link = l + "?s=32769";
				}
				link = baxide.generateUrl(link);
				$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='thumbnail'><img src='" + link + "' width='100' height='100'/></div></div>");

				var orientation = folderFiles[pos].orientation;
				switch (orientation) {
				case "right-top":
					$('.' + i + '.cell .thumbnail img').css('-webkit-transform', 'rotate(90deg)');
					break;
				case "bottom-right":
					$('.' + i + '.cell .thumbnail img').css('-webkit-transform', 'rotate(180deg)');

					break;
				case "left-bottom":
					$('.' + i + '.cell .thumbnail img').css('-webkit-transform', 'rotate(270deg)');

					break;
				}
				link = null;
				l = null;
				break;
			case "file":
				switch (folderFiles[pos].mime) {
				case "video/quicktime":
				case "video/x-ms-wmv":
				case "video/ogg":
				case "video/avi":
				case "video/msvideo":
				case "video/x-msvideo":
				case "video/x-matroska":
				case "video/mpeg":
				case "video/3gpp":
				case "application/octet-stream":
				case "video/mp4":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/icons/movie.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + folderFiles[pos].title + "</span></div></div>");
					break;
				case "application/pdf":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/icons/document_pdf.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + folderFiles[pos].title + "</span></div></div>");
					break;
				case "application/msword":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/icons/document_doc.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + folderFiles[pos].title + "</span></div></div>");
					break;
				case "text/html":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/icons/document_html.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + folderFiles[pos].title + "</span></div></div>");
					break;
				case "text/plain":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/icons/document_txt.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + folderFiles[pos].title + "</span></div></div>");
					break;
				case "application/excel":
				case "application/vnd.ms-excel":
				case "application/x-excel":
				case "application/x-msexcel":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/icons/document_xls.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + folderFiles[pos].title + "</span></div></div>");
					break;
				case "application/xml":
				case "text/xml":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/icons/document_xml.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + folderFiles[pos].title + "</span></div></div>");
					break;
				case "text/ccs":
				case "application/x-pointplus":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/icons/document_css.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + folderFiles[pos].title + "</span></div></div>");
					break;
				case "application/x-zip-compressed":
				case "application/x-compressed":
				case "multipart/x-zip":
				case "application/zip":
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/icons/box.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + folderFiles[pos].title + "</span></div></div>");
					break;
				case "audio/mpeg":
				case "audio/mpeg3":
				case "audio/x-mpeg-3":
				case "audio/mp3":
				case "audio/wav":
				case "audio/x-wav":
				case "audio/x-mpegurl":
				case "audio/mpegurl":
				case "audio/mpeg-url":
				case "audio/x-ms-wma":
					alert("node: " + folderFiles[pos].node);
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/icons/music.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + folderFiles[pos].title + "</span></div></div>");
					break;
				default:
					$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/icons/document.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + folderFiles[pos].title + "</span></div></div>");
				}
				break;

			default:
				$(gridId + " .row" + rownumber).append("<div class='" + i + " cell'><div class='image'><img src='images/icons/document.png' width='60' height='60'/></div><div class='title'><span class='" + i + "'>" + folderFiles[pos].title + "</span></div></div>");
			}
		}
	}
}

SceneDriveScene.prototype.focusCell = function (i) {
	$("." + (currentFocused + i) + ".cell").addClass("focus");
	currentFocused += i;
	alert("focuscell currentFocused " + currentFocused);
	if ($("span." + currentFocused).width() > $(".cell").width()) { //If title greater than cell, apply marquee. --> only works on 2012 tv
		$("span." + currentFocused).wrap("<marquee id='marquee'></marquee>");
		alert("wrap");
	}
}
SceneDriveScene.prototype.unFocusCell = function () {
	alert("unfocus currentFocused " + currentFocused);
	$("." + currentFocused + ".cell").removeClass("focus");
	//alert("unwrap:  "+$("span."+currentFocused).parent("marquee").attr("id"));
	if ($("span." + currentFocused).parent("marquee").attr("id") == "marquee") {
		$("span." + currentFocused).unwrap();
		alert("unwrap " + $("marquee").find("span." + currentFocused));
	}
}

SceneDriveScene.prototype.setFocus = function (tab) {
	//FAVORITES
	if (tab == "favorites") {
		alert("folderListIndex.length " + favoritesListIndex.length);
		if (favoritesListIndex.length > 0 && backward) {
			var lastIndex = favoritesListIndex.pop();
			if (lastIndex > numberElements)
				lastIndex = 0;
			//		$("."+lastIndex+".cell").addClass("focus");
			alert("this.scrollsize " + this.scrollSize);
			//		alert("Math.floor(lastIndex/filesPerRow) "+Math.floor(lastIndex/filesPerRow))
			//		alert("lastIndex: "+lastIndex+"   (10-(this.scrollsize*Math.floor(lastIndex/filesPerRow)))" +(20-(this.scrollSize*Math.floor(lastIndex/filesPerRow))));
			var row = Math.floor(lastIndex / filesPerRow);
			var totalRows = Math.floor(numberElements / filesPerRow);
			if (Math.floor(lastIndex / filesPerRow) > 3) {

				if (totalRows - row <= 2) {
					$(gridId).css("top", (50 - (this.scrollSize * Math.floor(lastIndex / filesPerRow)) + (this.scrollSize * (3 - (totalRows - row)))));
					currentRow = 3 - (totalRows - row);
				} else {
					$(gridId).css("top", (50 - (this.scrollSize * Math.floor(lastIndex / filesPerRow))));
					currentRow = 0;

				}
			} else {
				currentRow = row;
			}
			alert("top pos: " + $(gridId).position().top);
			backward = false;
			currentFocused = lastIndex;

		} else {
			//	$(".0.cell").addClass("focus");
			alert("setfocus currentFocused " + currentFocused);
			if (currentFocused === null) {
				currentFocused = 0;
				currentRow = 0;
			}
		}
		//this.focusCell(0);
	} else { //CLOUD DRIVE
		alert("folderListIndex.length " + folderListIndex.length);
		if (folderListIndex.length > 0 && backward) {
			var lastIndex = folderListIndex.pop();
			if (lastIndex > numberElements)
				lastIndex = 0;
			//		$("."+lastIndex+".cell").addClass("focus");
			alert("this.scrollsize " + this.scrollSize);
			alert("Math.floor(lastIndex/filesPerRow) " + Math.floor(lastIndex / filesPerRow))
			alert("lastIndex: " + lastIndex + "   (10-(this.scrollsize*Math.floor(lastIndex/filesPerRow)))" + (10 - (this.scrollSize * Math.floor(lastIndex / filesPerRow))));
			var row = Math.floor(lastIndex / filesPerRow);
			var totalRows = Math.floor(numberElements / filesPerRow);
			if (Math.floor(lastIndex / filesPerRow) > 3) {
				if (totalRows - row <= 2) {
					$(gridId).css("top", (50 - (this.scrollSize * Math.floor(lastIndex / filesPerRow)) + (this.scrollSize * (3 - (totalRows - row)))));
					currentRow = 3 - (totalRows - row);
				} else {
					$(gridId).css("top", (50 - (this.scrollSize * Math.floor(lastIndex / filesPerRow))));
					currentRow = 0;

				}
				//			c
				//				$(gridId).css("top", ($(gridId).css("top")+(this.scrollSize*(3-(totalRows-row)))));
			} else {
				currentRow = row;
			}
			alert("top pos: " + $(gridId).position().top);
			backward = false;
			currentFocused = lastIndex;

		} else {
			//	$(".0.cell").addClass("focus");
			alert("setfocus currentFocused " + currentFocused);
			if (currentFocused === null) {
				currentFocused = 0;
				currentRow = 0;
			}
		}

	}

	this.focusCell(0);
}

SceneDriveScene.prototype.adjustScrollBar = function (rownumber, position) {
	alert("SceneDriveScene.adjustScrollBar()");
	this.gridSize = document.getElementById(gridId.split('#')[1]);
	this.frame = document.getElementById("frame");

	var gridLength = this.gridSize.scrollHeight;
	var frameLength = this.frame.offsetHeight;

	alert("totalFiles == " + totalFiles + " fold.length == " + fold.length + " filesPerRow == " + filesPerRow);
	//this.pages = rownumber + 1;
	this.pages = Math.ceil((parseInt(totalFiles) + parseInt(fold.length)) / filesPerRow);
	alert("this.pages == " + this.pages + " gridLength == " + gridLength + " frameLength == " + frameLength);
	if (this.pages < 0) {
		this.pages = 0;
	}

	if (this.pages <= 1) {
		this.hideScrollBar();
	} else {
		this.showScrollBar(position);
	}
}

SceneDriveScene.prototype.showScrollBar = function (position) {
	alert("SceneDriveScene.showScrollBar()");
	$('#gridScroll').sfScroll({
		pages : this.pages
	});
	if (position == null)
		position = 0;
	$('#gridScroll').sfScroll('move', position);
	$('#gridScroll').sfScroll('show');
}

SceneDriveScene.prototype.hideScrollBar = function () {
	alert("SceneDriveScene.hideScrollBar()");
	$('#gridScroll').sfScroll('hide');
}

SceneDriveScene.prototype.moveGridUp = function () {
	var DesPosition = $(gridId).position().top;
	alert("up desposition: " + DesPosition);
	//				if(DesPosition < 0) {
	//				if(currentFocused <= (numberElements - filesPerRow*4) && currentFocused > filesPerRow*4){
	if (currentRow == 0) {
		alert("top: " + DesPosition + this.scrollSize);
		$(gridId).css("top", DesPosition + this.scrollSize);
		$('#gridScroll').sfScroll('prev');
	} else {
		alert("movel scroll");
		$('#gridScroll').sfScroll('prev');
	}

}

SceneDriveScene.prototype.moveGridDown = function () {
	var DesPosition = $(gridId).position().top;
	alert("down desposition: " + DesPosition);
	alert("down de this.gridSize.scrollHeight :" + this.gridSize.scrollHeight);
	alert("down de this.frame.offsetHeight :" + this.frame.offsetHeight);
	//				if(this.gridSize.scrollHeight-this.frame.offsetHeight > DesPosition*(-1)) {
	//				if(currentFocused / filesPerRow >= 4 &&currentFocused <= (numberElements - filesPerRow*4) ){
	if (currentRow == 3) {
		alert("move scroll");
		alert("top: " + DesPosition - this.scrollSize);
		$(gridId).css("top", DesPosition - this.scrollSize);
		$('#gridScroll').sfScroll('next');
	} else {
		alert("movel scroll");
		$('#gridScroll').sfScroll('next');
	}

}

SceneDriveScene.prototype.showVolume = function () {
	if (deviceapis.audiocontrol.getMute() == true) {
		$("#musicPlayer #volume").html("0%");
		var volPerc = 0;
		$("#musicPlayer #volumePercentage").css("width", volPerc);
	} else {
		var vol = deviceapis.audiocontrol.getVolume();
		$("#musicPlayer #volume").html(vol + "%");
		var volPerc = 40 * vol / 100;
		alert("vol perc " + volPerc);
		$("#musicPlayer #volumePercentage").css("width", volPerc);
	}

}

//selects the menu in the right that is visible, depending which tab is selected
SceneDriveScene.prototype.drawMenu = function (tab) {
	switch (tab) {
	case "clouddrive":
		$(".clouddrive_opt").css('visibility', 'visible');
		$(".webshares_opt").css('visibility', 'hidden');
		$(".favorites_opt").css('visibility', 'hidden');
		$(".playqueue_opt").css('visibility', 'hidden');
		break;
	case "webshares":
		$(".clouddrive_opt").css('visibility', 'hidden');
		$(".webshares_opt").css('visibility', 'visible');
		$(".favorites_opt").css('visibility', 'hidden');
		$(".playqueue_opt").css('visibility', 'hidden');
		break;
	case "favorites":
		$(".favorites_opt").css('visibility', 'visible');
		$(".clouddrive_opt").css('visibility', 'hidden');
		$(".webshares_opt").css('visibility', 'hidden');
		$(".playqueue_opt").css('visibility', 'hidden');
		break;
	case "playqueue":
		$(".favorites_opt").css('visibility', 'hidden');
		$(".clouddrive_opt").css('visibility', 'hidden');
		$(".webshares_opt").css('visibility', 'hidden');
		$(".playqueue_opt").css('visibility', 'visible');
		break;

	}
}

//selects the tab in the bar.
SceneDriveScene.prototype.selectTab = function (tab) {
	switch (tab) {
	case "clouddrive":
		$("#cloudme #clouddrive").css('background-color', 'rgba(255, 255, 255, 1)');
		$("#cloudme #webshares").css('background-color', 'rgba(0, 0, 0, 0.3)');
		$("#favorites").css('background-color', 'rgba(0, 0, 0, 0.3)');
		$("#cloudme #clouddrive").css('border-bottom', '1px solid white');
		$("#cloudme #webshares").css('border-bottom', '1px solid #68AEDD');
		$("#cloudme #favorites").css('border-bottom', '1px solid #68AEDD');
		$("#cloudme #clouddrive").css('color', 'black');
		$("#cloudme #webshares").css('color', 'white');
		$("#cloudme #favorites").css('color', 'white');
		$("#clouddrive .remoteImage").attr('src', 'images/remote48_da.png');
		$("#webshares .remoteImage").attr('src', 'images/remote48_da_white.png');
		$("#favorites .remoteImage").attr('src', 'images/remote48_da_white.png');

		break;
	case "webshares":
		$("#cloudme #clouddrive").css('background-color', 'rgba(0, 0, 0, 0.3)');
		$("#webshares").css('background-color', 'rgba(255, 255, 255, 1)');
		$("#favorites").css('background-color', 'rgba(0, 0, 0, 0.3)');
		$("#cloudme #clouddrive").css('border-bottom', '1px solid #68AEDD');
		$("#cloudme #webshares").css('border-bottom', '1px solid white');
		$("#cloudme #favorites").css('border-bottom', '1px solid #68AEDD');
		$("#cloudme #clouddrive").css('color', 'white');
		$("#cloudme #webshares").css('color', 'black');
		$("#cloudme #favorites").css('color', 'white');
		$("#clouddrive .remoteImage").attr('src', 'images/remote48_da_white.png');
		$("#webshares .remoteImage").attr('src', 'images/remote48_da.png');
		$("#favorites .remoteImage").attr('src', 'images/remote48_da_white.png');

		break;
	case "favorites":
		$("#clouddrive").css('background-color', 'rgba(0, 0, 0, 0.3)');
		$("#cloudme #webshares").css('background-color', 'rgba(0, 0, 0, 0.3)');
		$("#cloudme #favorites").css('background-color', 'rgba(255, 255, 255, 1)');
		$("#cloudme #clouddrive").css('border-bottom', '1px solid #68AEDD');
		$("#cloudme #webshares").css('border-bottom', '1px solid #68AEDD');
		$("#cloudme #favorites").css('border-bottom', '1px solid white');
		$("#cloudme #clouddrive").css('color', 'white');
		$("#cloudme #webshares").css('color', 'white');
		$("#cloudme #favorites").css('color', 'black');
		$("#clouddrive .remoteImage").attr('src', 'images/remote48_da_white.png');
		$("#webshares .remoteImage").attr('src', 'images/remote48_da_white.png');
		$("#favorites .remoteImage").attr('src', 'images/remote48_da.png');

		break;
	}
}

//show the info depending the file type
SceneDriveScene.prototype.showInfo = function () {

	alert("INFO");
	if (currentFocused >= fold.length) {

		alert("Is a File");
		pos = currentFocused - fold.length;
		alert("file " + folderFiles[pos].title + " is a " + folderFiles[pos].type);
		alert("FILE mime: " + folderFiles[pos].mime);
		alert("FILE updated: " + folderFiles[pos].updated);
		alert("FILE size: " + folderFiles[pos].size);
		var info;
		switch (folderFiles[pos].mime.split("/")[0]) {
		case "audio":

			info = STR_TYPE + " " + folderFiles[pos].mime + " </br> " + STR_UPDATED + " " + folderFiles[pos].updated.substr(0, 10) + "</br>" + STR_SIZE + " " + folderFiles[pos].size + "</br>" + STR_ARTIST + " " + folderFiles[pos].artist + "</br>" + STR_SONG + " " + folderFiles[pos].song + "</br>" + STR_ALBUM + " " + folderFiles[pos].album + "</br>" + STR_YEAR + " " + folderFiles[pos].year + "</br>" + STR_GENRE + " " + folderFiles[pos].genre + "</br>" + STR_DURATION + " " + folderFiles[pos].duration + "</br>" + STR_COMPOSER + " " + folderFiles[pos].composer + "</br>" + STR_TRACK + " " + folderFiles[pos].track + "</br>" + STR_RATE + " " + folderFiles[pos].rate;
			break;
		case "image":
			info = STR_TYPE + " " +

				[pos].mime + " </br> " + STR_UPDATED + " " + folderFiles[pos].updated.substr(0, 10) + "</br>" + STR_SIZE + ": " + folderFiles[pos].size + "</br>" + STR_CAMERA + " " + folderFiles[pos].camera + "</br>" + STR_MODEL + " " + folderFiles[pos].camera_model + "</br> Flash " + folderFiles[pos].flash + "</br>dpi " + folderFiles[pos].dpi + "</br> ISO: " + folderFiles[pos].iso + "</br> Focal " + folderFiles[pos].focal + "</br>" + STR_APERTURE + " " + folderFiles[pos].aperture + "</br>" + STR_EXPOSURE + " " + folderFiles[pos].exposure;
			break;
		default:
			info = STR_TYPE + " " + folderFiles[pos].mime + " </br> " + STR_UPDATED + " " + folderFiles[pos].updated.substr(0, 10) + "</br>" + STR_SIZE + " " + folderFiles[pos].size;
			break;
		}
		$('#info_popup').sfPopup({
			title : folderFiles[pos].title,
			text : info,
			buttons : ["Ok"],
			defaultFocus : 0,
			timeout : 0,
			callback : function newFolderCallback(selectedIndex) {}
		});

		$('#info_popup').sfPopup('show');
	}
}

//Shows the favorite info with the description (descr)
SceneDriveScene.prototype.fillMenu = function (descr) {
	alert("fav pos: " + currentFocused);
	$("#fav_name").html(fold[currentFocused].title);

	$("#sharedText").html(fold[currentFocused].sharingUserName);
	if (descr == undefined || descr == null || descr == "") {
		$("#fav_description").css("visibility", "hidden");
		$("#descriptionText").html("");
	} else {
		$("#fav_description").css("visibility", "visible");
		$("#descriptionText").html(descr);
	}
}

SceneDriveScene.prototype.showAddFavoritePopup = function () {

	$('#favorite_popup').sfPopup({
		title : STR_ADD_FAVORITE,
		text : "Username: </br> WebShare: ",
		buttons : [STR_OK, STR_CANCEL],
		timeout : 0,
		defaultFocus : -1,
		callback : function newFolderCallback(selectedIndex) {
			alert("popup_callback selected: " + selectedIndex);
			if (selectedIndex == 0) {
				controller.addFavorite();
			}
		},

		onkeydown : function (keyCode) {
			alert("KEYDOWN : " + keyCode);
			switch (keyCode) {
			case sf.key.UP:
				document.getElementById("favWebshareInput").focus();
				$('#favorite_popup').sfPopup("option", "focus", "-1");
				break;

			case sf.key.LEFT:
				$('#favorite_popup').sfPopup("option", "focus", "0");
				break;

			case sf.key.RIGHT:
				$('#favorite_popup').sfPopup("option", "focus", "1");
				break;
			case sf.key.ENTER:
				$('#favorite_popup').sfPopup("hide");
				break;
			}
		}
	});
	$('#favorite_popup').sfPopup('show');
	$('#favorite_popup').append('<input id="favUsernameInput" type="text" size="20" />');
	$('#favorite_popup').append('<input id="favWebshareInput" type="text" size="20" />');
	ime_favUsername = new IMEShell("favUsernameInput", callback_favorite_username, "en");
	ime_favWebshare = new IMEShell("favWebshareInput", callback_favorite_webshare, "en");
	var xPosition;
	switch (sf.env.getResolution()) {
	case '540p':
		xPosition = 680;
		break;
	case '720p':
		xPosition = 880;
		break;
	case '1080p':
		xPosition = 1080;
		break;
	}
	ime_favUsername.setKeypadPos(xPosition, 70, 9);
	ime_favWebshare.setKeypadPos(xPosition, 70, 9);
	ime_favWebshare.setString("");
	ime_favUsername.setString("");
	document.getElementById("favUsernameInput").focus(); //focus the input title
	$("#ime_keypad").css('opacity', '1');
	$("#ime_keypad").css('z-index', '50');
}

function callback_favorite_username(cb) { //popup callback function
	cb.setKeyFunc(sf.key.DOWN, function (keyCode) {
		document.getElementById("favUsernameInput").blur();
		document.getElementById("favWebshareInput").focus();
		$("#ime_keypad").css('opacity', '1');
		$("#ime_keypad").css('z-index', '50');
		return false;
	});
	//	cb.setKeyFunc(sf.key.ENTER, function(keyCode) { document.getElementById("newFolder").blur(); sf.scene.returnFocus(); $('#newFolder_popup').sfPopup('show');  return false; } );
	cb.setKeyFunc(sf.key.RETURN, function (keyCode) {
		document.getElementById("favUsernameInput").blur();
		sf.scene.returnFocus();
		$('#favorite_popup').sfPopup('hide');
		sf.key.preventDefault();
		return false;
	});
	cb.setKeyFunc(sf.key.EXIT, function (keyCode) {
		alert("exit");
		sf.core.exit(true);
	});
}
function callback_favorite_webshare(cb) { //popup callback function
	alert("callback called");
	cb.setKeyFunc(sf.key.DOWN, function (keyCode) {
		alert("down ");
		document.getElementById("favWebshareInput").blur();
		sf.scene.returnFocus();
		$('#favorite_popup').sfPopup('show');
		$('#favorite_popup').sfPopup("option", "focus", "1");
		return false;
	});
	//	cb.setKeyFunc(sf.key.ENTER, function(keyCode) { document.getElementById("newFolder").blur(); sf.scene.returnFocus(); $('#newFolder_popup').sfPopup('show');  return false; } );
	cb.setKeyFunc(sf.key.RETURN, function (keyCode) {
		document.getElementById("favWebshareInput").blur();
		sf.scene.returnFocus();
		$('#favorite_popup').sfPopup('hide');
		sf.key.preventDefault();
		return false;
	});

	cb.setKeyFunc(sf.key.UP, function (keyCode) {
		document.getElementById("favWebshareInput").blur();
		document.getElementById("favUsernameInput").focus();
		$("#ime_").css('opacity', '1');
		$("#ime_keypad").css('z-index', '50');
		return false;
	});
	cb.setKeyFunc(sf.key.EXIT, function (keyCode) {
		alert("exit");
		sf.core.exit(true);
	});
}

function callback_favorite_password(cb) { //popup callback function
	alert("callback called");
	cb.setKeyFunc(sf.key.DOWN, function (keyCode) {
		alert("down ");
		document.getElementById("favPasswordInput").blur();
		sf.scene.returnFocus();
		$('#favorite_popup').sfPopup('show');
		$('#favorite_popup').sfPopup("option", "focus", "1");
		return false;
	});
	//	cb.setKeyFunc(sf.key.ENTER, function(keyCode) { document.getElementById("newFolder").blur(); sf.scene.returnFocus(); $('#newFolder_popup').sfPopup('show');  return false; } );
	cb.setKeyFunc(sf.key.RETURN, function (keyCode) {
		document.getElementById("favPasswordInput").blur();
		sf.scene.returnFocus();
		$('#favorite_popup').sfPopup('hide');
		sf.key.preventDefault();
		return false;
	});
	cb.setKeyFunc(sf.key.EXIT, function (keyCode) {
		alert("exit");
		sf.core.exit(true);
	});
	//	cb.setKeyFunc(sf.key.RIGHT, function(keyCode) {alert("right"); return false;});
	//	cb.setKeyFunc(sf.key.LEFT, function(keyCode) {alert("left"); return false;});
	//	cb.setKeyFunc(sf.key.UP, function(keyCode) {document.getElementById("newFolder").focus();   return false;});
	//	cb.setKeyFunc(sf.key.EXIT, function(keyCode) {alert("exit"); sf.core.exit(true); });
}

SceneDriveScene.showFavoritePwdPopup = function (username, webshare) {

	$('#favorite_popup').sfPopup({
		title : STR_ADD_FAVORITE,
		text : "Password:",
		buttons : [STR_OK, STR_CANCEL],
		timeout : 0,
		defaultFocus : 1,
		callback : function newFolderCallback(selectedIndex) {
			alert("popup_callback");
			if (selectedIndex == 0) {
				controller.addFavorite(username, webshare);
			}
		},
		onkeydown : function (keyCode) {
			alert("KEYDOWN : " + keyCode);
			switch (keyCode) {
			case sf.key.UP:
				document.getElementById("favPasswordInput").focus();
				break;

			case sf.key.LEFT:
				$('#favorite_popup').sfPopup("option", "focus", "0");
				break;

			case sf.key.RIGHT:
				$('#favorite_popup').sfPopup("option", "focus", "1");
				break;
			case sf.key.ENTER:
				$('#favorite_popup').sfPopup("hide");
				break;
			}
		}

	});
	$('#favorite_popup').sfPopup('show');
	$('#favorite_popup').append('<input id="favPasswordInput" type="password" size="20" />');
	ime_favPassword = new IMEShell("favPasswordInput", callback_favorite_password, "en");
	var xPosition;
	switch (sf.env.getResolution()) {
	case '540p':
		xPosition = 680;
		break;
	case '720p':
		xPosition = 880;
		break;
	case '1080p':
		xPosition = 1080;
		break;
	}
	ime_favPassword.setKeypadPos(xPosition, 70, 9);
	document.getElementById("favPasswordInput").focus(); //focus the input title
	$("#ime_keypad").css('opacity', '1');
	$("#ime_keypad").css('z-index', '50');

}

SceneDriveScene.prototype.showErrorPopup = function (error_str) {
	alert("error: " + error_str);
	$('#error_popup').sfPopup({
		title : "Error",
		text : error_str,
		buttons : [STR_OK],
		defaultFocus : 0,
		callback : function newFolderCallback(selectedIndex) {}
	});
	$('#error_popup').sfPopup('show');
}

//Sets cloud drive tab
SceneDriveScene.prototype.setCloudDrive = function () {
	$("#fav_description").css("visibility", "hidden");
	$('#loadingDrive').sfLoading('show');
	$(gridId).empty();
	currentTab = "clouddrive";
	currentFocused = 0;
	this.drawMenu(currentTab); //change menu
	this.selectTab(currentTab);
	//draw route


	route = new Array();
	//folderRoute.push("Cloud Drive");
	controller.drawRoute(currentTab);
	//listIndex = new Array();


	$('#svecKeyHelp_IIZH').sfKeyHelp({
		'user' : states.username,
		'red' : STR_LOGOUT,
		'green' : STR_SORT,
		'yellow' : STR_PLAYQUEUE,
		'blue' : STR_SEARCH,
		'enter' : STR_ENTER,
		'updown' : STR_UP_DOWN,
		'info' : STR_FILE_INFO,
		'return' : STR_BACK
	});
	if (folderIdTree[folderIdTree.length - 1] == 0) { // If search view (last index == 0)
		//folderIdTree.pop()
		fold = search.searchResultFolders;
		folderFiles = search.searchResultFiles;
		//						while(folderRoute.length > (folderIdTree.length+1)) folderRoute.pop();
		//check images and audio files
		var i;
		audioFiles = new Array();
		imageFiles = new Array();
		for (i = 0; i < folderFiles.length; i++) {
			if (folderFiles[i].mime == "audio/mp3" || folderFiles[i].mime == "audio/mpeg") {
				audioFiles.push(folderFiles[i]);
			}
			if (folderFiles[i].mime == "image/jpeg" || folderFiles[i].mime == "image/jpg" || folderFiles[i].mime == "image/png" || folderFiles[i].mime == "image/gif") {
				imageFiles.push(folderFiles[i]);
			}
		}
		//						folderIdTree.push(0);
		//						currentFocused = 0;
		this.unFocusCell();
		sf.scene.focus('DriveScene');
	} else {
		controller.handleFolder(folderIdTree.pop());
	}
}

//Sets favorites tab
SceneDriveScene.prototype.setFavorites = function () {
	currentTab = "favorites";
	currentFocused = 0;
	$('#loadingDrive').sfLoading('show');
	$(gridId).empty();
	this.drawMenu(currentTab); // change menu
	this.selectTab(currentTab);
	// query for favorites
	if (favoritesRoute.length == 1) {
		controller.loadFavorites();
	} else {
		alert("favoriteId " + favoriteId);
		controller.openFavorite(favoriteId, true, favoritesRoute);
	}

	//Draw the route
	route = new Array();
	//favoritesRoute.push("Favorites");
	alert("tab: " + currentTab);
	controller.drawRoute(currentTab);
	//listIndex = new Array();
	$('#svecKeyHelp_IIZH').sfKeyHelp({
		'user' : states.username,
		'red' : STR_LOGOUT,
		'yellow' : STR_PLAYQUEUE,
		'enter' : STR_ENTER,
		'updown' : STR_UP_DOWN,
		'info' : STR_FILE_INFO,
		'return' : STR_BACK
	});

}

//Sets search options
SceneDriveScene.prototype.setSearch = function () {
	$("#newFolder").css("opacity", "0.3");
	$("#copy").css("opacity", "0.3");
	$("#move").css("opacity", "0.3");
	$("#multipleSelect").css("opacity", "0.3");
}

SceneDriveScene.prototype.unsetSearch = function () {
	$("#newFolder").css("opacity", "1");
	$("#copy").css("opacity", "1");
	$("#move").css("opacity", "1");
	$("#multipleSelect").css("opacity", "1");
}

SceneDriveScene.prototype.loadMore = function () {
	alert("fold.le  " + fold.length + "   folderFiles.length " + folderFiles.length + "   totalFiles " + totalFiles);

	if (folderFiles.length < totalFiles && (numberElements - currentFocused) <= 7 && !loading && currentTab == "clouddrive") {
		loading = true;
		controller.loadMore(states.currentFolderId);
	}
}
