function ScenePlayQueueScene(options) {
	this.options = options;
	this.scrollSize = 100;
	this.pages = null;
	this.pos = 0;
	this.itemSelected = null;

}

var playListName;
var randomPlay;
var maxTimesPlayed;

ScenePlayQueueScene.prototype.initialize = function () {
	alert("ScenePlayQueueScene.initialize()");
	// this function will be called only once when the scene manager show this scene first time
	// initialize the scene controls and styles, and initialize your variables here
	// scene HTML and CSS will be loaded before this function is called
	randomPlay = false;
};

ScenePlayQueueScene.prototype.handleShow = function () {
	alert("ScenePlayQueueScene.handleShow()");
	// this function will be called when the scene manager show this scene
};

ScenePlayQueueScene.prototype.handleHide = function (nextTab) { //return?
	alert("ScenePlayQueueScene.handleHide()");
	// this function will be called when the scene manager hide this scene
	if (sf.scene.getVisible('DriveScene')) {

		switch (nextTab || currentTab) {
		case "clouddrive":
			if (nextTab == undefined || nextTab == currentTab) {
				SceneDriveScene.prototype.drawMenu("clouddrive");
				$('#svecKeyHelp_IIZH').sfKeyHelp({
					'user' : states.username,
					'red' : STR_LOGOUT,
					'green' : STR_SORT,
					'yellow' : STR_PLAYQUEUE,
					'blue' : STR_SEARCH,
					'enter' : STR_ENTER,
					'updown' : STR_UP_DOWN,
					'info' : STR_FILE_INFO,
					'return' : STR_BACK
				});
				sf.scene.focus('DriveScene', true);
			} else {
				if (sf.scene.getVisible('WebSharesScene')){
					sf.scene.hide('WebSharesScene');
					SceneDriveScene.prototype.setCloudDrive();
					sf.scene.focus('DriveScene', true);
				}else{
					SceneDriveScene.prototype.setCloudDrive();
				}
			}
			break;
		case "webshares":
			if (nextTab == undefined || nextTab == currentTab) {
				SceneDriveScene.prototype.drawMenu("webshares"); //change menu
				sf.scene.focus('WebSharesScene');
			} else {
				SceneDriveScene.prototype.drawMenu("webshares"); //change menu
				if (currentTab != "webshares") {
					//			$('#loadingDrive').sfLoading('show');
					currentTab = "webshares";
					SceneDriveScene.prototype.selectTab(currentTab);
					//favoriteId = null;
					controller.getWebShares();
					currentFocused = null;
				}
				sf.scene.focus('WebSharesScene');
			}

			break;
		case "favorites":
			if (nextTab == undefined || nextTab == currentTab) {
				SceneDriveScene.prototype.drawMenu("favorites"); //change menu
				$('#svecKeyHelp_IIZH').sfKeyHelp({
					'user' : states.username,
					'red' : STR_LOGOUT,
					'yellow' : STR_PLAYQUEUE,
					'enter' : STR_ENTER,
					'updown' : STR_UP_DOWN,
					'info' : STR_FILE_INFO,
					'return' : STR_BACK
				});
				sf.scene.focus('DriveScene', true);
			} else {
				if (sf.scene.getVisible('WebSharesScene')){
					sf.scene.hide('WebSharesScene');
					SceneDriveScene.prototype.setFavorites();
					sf.scene.focus('DriveScene', true);
				}else{
					SceneDriveScene.prototype.setFavorites();
				}
			}

			break;
		case "clouddriveplaylists":
			SceneDriveScene.prototype.setCloudDrive();
			break;

		}

	}

};

ScenePlayQueueScene.prototype.handleFocus = function () {
	alert("ScenePlayQueueScene.handleFocus()");
	// this function will be called when the scene manager focus this scene
	$('#svecKeyHelp_IIZH').sfKeyHelp({
		'user' : states.username,
		'red' : STR_LOGOUT,
		'enter' : STR_ENTER,
		'updown' : STR_UP_DOWN
	});

	this.reloadPlayQueue();
	SceneDriveScene.prototype.drawMenu("playqueue");
	$('#playQueueScroll').sfScroll('move', 0);
	$('#playQueueList').sfList('move', 0);
	if (playListLoaded != undefined && playListLoaded != null && playListLoaded.name != undefined && playListLoaded.name != null) {
		alert("playListLoaded.name  " + playListLoaded.name);
		$('#playQueueTitle').html(playListLoaded.name.replace(".m3u", ""));
	} else {
		$('#playQueueTitle').html("Play Queue");
	}

	$("#fav_description").css("visibility", "hidden");
}

ScenePlayQueueScene.prototype.handleBlur = function () {
	alert("ScenePlayQueueScene.handleBlur()");
	// this function will be called when the scene manager move focus to another scene from this scene
}

ScenePlayQueueScene.prototype.handleKeyDown = function (keyCode) {
	alert("ScenePlayQueueScene.handleKeyDown(" + keyCode + ")");
	// TODO : write an key event handler when this scene get focued
	switch (keyCode) {
	case sf.key.LEFT:
		break;
	case sf.key.RIGHT:
		break;
	case sf.key.UP:
		var idx = $('#playQueueList').sfList('getIndex');
		if (idx == 0) {
			$('#playQueueScroll').sfScroll('move', Math.ceil(playQueue.length / 10) - 1);
		} else {
			if ((idx % 10) == 0)
				$('#playQueueScroll').sfScroll('prev');
		}
		$('#playQueueList').sfList('prev');
		this.drawSpeaker();
		break;
	case sf.key.DOWN:
		var idx = $('#playQueueList').sfList('getIndex');
		if (idx == playQueue.length - 1) {
			$('#playQueueScroll').sfScroll('move', 0);
		} else {
			if ((idx + 1) % 10 == 0)
				$('#playQueueScroll').sfScroll('next');
		}
		$('#playQueueList').sfList('next');
		this.drawSpeaker();
		break;
	case sf.key.ENTER:
		controller.playMusic($('#playQueueList').sfList('getIndex'));
		this.drawSpeaker();
		break;
	case sf.key.RETURN:
		sf.scene.hide('PlayQueueScene');

		sf.key.preventDefault();
		break;

	case sf.key.N1: //cloud drive
		sf.scene.hide('PlayQueueScene', "clouddrive");
		break;
	case sf.key.N2: //cloud drive
		sf.scene.hide('PlayQueueScene', "webshares");
		break;
	case sf.key.N3: //Favorites
		sf.scene.hide('PlayQueueScene', "favorites");
		break;
	case sf.key.N4: //Favorites
		//this.setRandom();
		break;
	case sf.key.N5: //Move
		if (this.itemSelected == null) {
			var pos = $('#playQueueList').sfList('getIndex');
			$('#playQueueList').sfList('blur');
			this.itemSelected = pos;
		} else {
			var index = $('#playQueueList').sfList('getIndex');
			if (index != this.itemSelected) {
				playQueue.splice(index, 0, playQueue[this.itemSelected]);
				if (index > this.itemSelected) {
					playQueue.splice(this.itemSelected, 1);
					this.reloadPlayQueue(index - 1);
				} else {
					playQueue.splice(this.itemSelected + 1, 1);
					this.reloadPlayQueue(index);
				}
				//controller.savePlayList();
				controller.syncPlayQueue();
			}
			this.itemSelected = null;
		}
		break;
	case sf.key.N6: //RemoveSong
		this.removeSong($('#playQueueList').sfList('getIndex'));

		break;
	case sf.key.N7: //¨Load
		//go to music / playlists
		controller.goToPlaylists();

		break;
	case sf.key.N8: //RemoveSong
		this.clearPlayQueue();

		break;
	case sf.key.N9: //RemoveSong
		//save playlist / playqueue
		$('#playList_popup').sfPopup({
			text : STR_SAVE_PLAYLIST,
			buttons : [STR_OK, STR_CANCEL],
			timeout : 0,
			defaultFocus : 1,
			callback : function newFolderCallback(selectedIndex) {
				if (selectedIndex == 0) {
					var title = $('#playListInput').val()
						title = title.split(".mp3")[0];
					controller.savePlayList(title);
					$('#playQueueTitle').html(title);
				}
			}
		});
		$('#playList_popup').sfPopup('show');

		$('#playList_popup').append('<input id="playListInput" type="text" size="20" />');
		var ime_newFolder = new IMEShell("playListInput", callback_playList, "en");
		var xPosition;
		switch (sf.env.getResolution()) {
		case '540p':
			xPosition = 680;
			break;
		case '720p':
			xPosition = 880;
			break;
		case '1080p':
			xPosition = 1080;
			break;
		}

		ime_newFolder.setKeypadPos(xPosition, 70, 9);

		if (playListLoaded == null || (playListLoaded.name == "playqueueatom.m3u" && playListLoaded.folder == states.libFolderId)) {

			ime_newFolder.setString("");
		} else {
			alert("playListLoaded.name: " + playListLoaded.name);
			ime_newFolder.setString(playListLoaded.name);
		}
		document.getElementById("playListInput").focus(); //focus the input title
		$("#ime_keypad").css('opacity', '1');
		$("#ime_keypad").css('z-index', '50');

		break;

	case sf.key.RED:
		if (playingAudio) {
			$("#musicPlay").attr("src", "images/control/media_play.png");
			$("#musicPause").attr("src", "images/control/media_pause_red.png");
			PlayerPlugin.Pause();
		}
		//Show logout popup
		$('#pq_logout_popup').sfPopup({
			text : STR_LOGOUT_POPUP,
			buttons : [STR_YES, STR_NO],
			defaultFocus : 1,
			callback : function logoutCallback(selectedIndex) {
				if (selectedIndex == 0) {
					alert("Loging out");
					sf.scene.hide("DriveScene");
					sf.scene.hide("PlayQueueScene");

					controller.logout();
				}
			}
		});
		$('#pq_logout_popup').sfPopup('show');
		break;

	case sf.key.PLAY:
		alert("PLAY");
		if (playingAudio) {
			$("#musicPlay").attr("src", "images/control/media_play_green.png");
			$("#musicPause").attr("src", "images/control/media_pause.png");
			PlayerPlugin.Resume();
		} else {
			controller.playMusic();
			this.drawSpeaker();
		}

		break;

	case sf.key.STOP:
		alert("STOP");
		playingAudio = false;
		$("#musicPlay").attr("src", "images/control/media_play.png");
		$("#musicPause").attr("src", "images/control/media_pause.png");
		//	$("#songTitle").html("");
		$("#progressBar").css("width", "0");
		$("#musicPlayer #time").html("00:00:00"); //time = 00:00:00
		PlayerPlugin.Stop();

		break;

	case sf.key.PAUSE:
		alert("PAUSE");
		$("#musicPlay").attr("src", "images/control/media_play.png");
		$("#musicPause").attr("src", "images/control/media_pause_red.png");
		PlayerPlugin.Pause();
		break;

	case sf.key.FF:
		alert("FF: " + currentAudio + "  length: " + playQueue.length);
		$("#musicFF").attr("src", "images/control/media_step_forward_green.png");
		setTimeout('$("#musicFF").attr("src", "images/control/media_step_forward.png");', 1000);
		controller.playNextSong(1);
		this.drawSpeaker();
		break;

	case sf.key.REW:
		alert("RW");
		$("#musicRW").attr("src", "images/control/media_step_back_green.png");
		setTimeout('$("#musicRW").attr("src", "images/control/media_step_back.png");', 1000);
		controller.playNextSong(-1);
		this.drawSpeaker();
		break;
	case sf.key.VOL_UP:
		alert("Vol up");
		deviceapis.audiocontrol.setVolumeUp();
		SceneDriveScene.prototype.showVolume();

		//    if(Player.getState() != Player.PAUSED)
		//       Player.skipBackwardVideo();
		break;
	case sf.key.VOL_DOWN:
		alert("Vol down");
		deviceapis.audiocontrol.setVolumeDown();

		SceneDriveScene.prototype.showVolume();
		//    if(Player.getState() != Player.PAUSED)
		//       Player.skipBackwardVideo();
		break;
	case sf.key.MUTE:
		alert("MUTE");
		if (deviceapis.audiocontrol.getMute() == true) {
			deviceapis.audiocontrol.setMute(false);
		} else {
			deviceapis.audiocontrol.setMute(true);
		}
		SceneDriveScene.prototype.showVolume();
		break;
	}
}
function callback_playList(cb) { //popup callback function
	alert("callback called");
	cb.setKeyFunc(sf.key.DOWN, function (keyCode) {
		alert("down ");
		document.getElementById("playListInput").blur();
		sf.scene.returnFocus();
		$('#playList_popup').sfPopup('show');
		return false;
	});
	cb.setKeyFunc(sf.key.ENTER, function (keyCode) {
		document.getElementById("playListInput").blur();
		sf.scene.returnFocus();
		$('#playList_popup').sfPopup('show');
		return false;
	});
	cb.setKeyFunc(sf.key.RETURN, function (keyCode) {
		document.getElementById("playListInput").blur();
		sf.scene.returnFocus();
		$('#playList_popup').sfPopup('hide');
		sf.key.preventDefault();
		return false;
	});
	cb.setKeyFunc(sf.key.EXIT, function (keyCode) {
		alert("exit");
		sf.core.exit(true);
	});
}

ScenePlayQueueScene.prototype.removeSong = function (index) {
	alert(playQueue[index]);
	playQueue.splice(index, 1);
	alert(playQueue[index]);
	if (currentAudio > index) {
		currentAudio -= 1;
		baxide.playqueuePosition("PUT");
	}
	this.reloadPlayQueue(index);
	//controller.savePlayList();
	controller.syncPlayQueue();
};

ScenePlayQueueScene.prototype.clearPlayQueue = function () {

	playQueue = new Array();
	$('#playQueueList').sfList('clear');
	$('#playQueueTitle').html("Play Queue");
	playListLoaded = null;
	currentAudio = null;
	$("#playingImage").css("visibility", "hidden");
	//controller.savePlayList();
	controller.syncPlayQueue();
	//update play queue view
};

ScenePlayQueueScene.prototype.reloadPlayQueue = function (index) {
	//update play queue view
	alert("pLAYQUEUE.LENGTH " + playQueue.length);
	$('#playQueueList').empty();
	$('#playQueueList').sfList({
		data : $.map(playQueue, function (value, key) {
			return value.artistSong || value.title;
		}),
		itemsPerPage : 10
	});
	$('#playQueueList').sfList('show');
	//	$('#playQueueList').sfList('focus');
	$('#playQueueList').sfList('move', index);
	//update scroll bar
	$('#playQueueScroll').sfScroll({
		pages : Math.ceil(playQueue.length / 10)
	});

	$('#playQueueScroll').sfScroll('show');
	if (index == null)
		index = 0;
	$('#playQueueScroll').sfScroll('move', index);
	this.drawSpeaker();
};

ScenePlayQueueScene.prototype.drawSpeaker = function () {
	var top = 74 + (currentAudio % 10) * 48; // set position speaker pos
	alert("top: " + top);

	alert("foc 123: " + Math.floor($('#playQueueList').sfList("getIndex") / 10));
	alert("tplayin: " + Math.floor(currentAudio / 10));
	if (Math.floor($('#playQueueList').sfList("getIndex") / 10) == Math.floor(currentAudio / 10)) {
		$("#playingImage").css("top", top + "px");
		$("#playingImage").css("visibility", "visible");
	} else {
		$("#playingImage").css("visibility", "hidden");
	}

};

ScenePlayQueueScene.prototype.setRandom = function () {
	if (randomPlay) {
		randomPlay = false;
	} else {
		randomPlay = true;
	}

}
